; Progname:ZBDBZ83
; ------------------------------------------------
; --						--
; --	DRAGON BALL Z 83, La bataille Sayenne	--
; --					V0.5	--
; --						--
; --						--
; --		By A.P.S., Dec 1999~Fev 2002	--
; --						--
; --	E-Mail:kameha@voila.fr			--
; --		or/ou alexp_soeiro@hotmail.com	--
; --						--
; --  Please, don't modifiy anything for a new	--
; --  distribution. You can modify this program --
; --  only for your personal purpose. Thanks.	--
; --						--
; --  Ne modifiez ce programme que dans un but	--
; --	purement personnel. Merci.		--
; --						--
; -- All characters and names are copyright of	--
; -- Akira Toriyama and Bird Studio.		--
; --						--
; --	Tous les noms et personnages sont la 	--
; -- prorpit exclusive d'Akira Toriyama et de	--
; -- Bird Studio.				--
; --						--
; --						--
; --	The program is copyright ; Le programme	--
; --  est un copyright : By A.P.S.		--
; --						--
; --  Ce programme est un freeware - This is a	--
; --	freeware program.			--
; --						--
; ------------------------------------------------

.NOLIST
#define end .end
#define END .end
#define equ .equ
#define EQU .equ
#include "ti83asm.inc"
#include "tokens.inc"

; ----------------------------------------
; --	Equivalences pour les touches	--
; ----------------------------------------

kdown		equ	34
kup		equ	25
kleft		equ	24
kright	equ	26
kshift	equ	21
kalpha	equ	31
kmode		equ	22
kclear	equ	45
kenter	equ	105
kvar		equ	32

kmenup	equ	03
kmendn	equ	04
kmenclr	equ	09
kmenent	equ	05

; ----------------------------------------
; --    Dclarations des variables	--
; ----------------------------------------
; Elles sont stockes dans la zone de calcul statistiques (STATVARS).

numperso		EQU	858Fh	; 1=goku,2=gohan,3=gothen
					; \4=vegeta,5=trunks
numsaiyen		EQU	8590h
numennemi		EQU	8591h	; Mmorise le perso de l'ennemi.
ordreennemi		EQU	8592h 	; Pour l'ennemi  affronter.
force			EQU	8593h	; Mmorise le force.
vie			EQU	8595h	; Mmorise la vie.
vieperso		EQU	8597h
forceperso		EQU	8598h
vieennemi		EQU	8599h
forceennemi		EQU	859Ah
bondr			EQU	859Bh	; 2 octets
coord.bondr		EQU	859Dh	; Y,X (2 octets)
actiondr		EQU	859Fh	; Mmorise si une action est faite
chargedr		EQU	85A0h	; Vrifie si perso D se charge
etatdr			EQU	85A1h	; Ca c'est pour Super sayen et autres
prisedr			EQU	85A2h
bonga			EQU	85A3h	; 2 octets
coord.bonga		EQU	85A5h	; Y,X (2 octets)
actionga		EQU	85A7h
chargega		EQU	85A8h
etatga			EQU	85A9h
prisega			EQU	85AAh
etat			EQU	85ABh
indexcoup		EQU	85ACh
coord.kamehaga		EQU	85ADh	; 2 octets
coord.kameha		EQU	85AFh	; Y,X (2 octets)
dessin.kameha		EQU	85B1h	; Faible,Fort: pointeur mem du sprite du kam (2 octets)
bopcoup			EQU	85B3h 	; 2 octets
senzu			EQU	85B5h
sprite.hauteur		EQU	85B6h
sprite.largeur		EQU	85B7h
textg.coord.pers	EQU	85B8h 	; coord. affichage nom perso. (2 octets)


.LIST
.org 9327h

;-------------------------------------------------
;--	 	Page de presentation 		--
;-- 		Choix du personnage 		--
;-------------------------------------------------

	nop				; Compatibilit avec
	jr debut			; ASHELL et SOS
	.dw $0000			; 
	.dw Description			;
	.dw Icone
debut:
	CALL	_runIndicOff		; Enleve l'indicateur de
	CALL	_CLRLCDFULL		; \fonctionnement
	CALL	_GRBUFCLR
	RES	plotdisp,(iy+plotflags)	; permet la sauvegarde
	RES	plotloc,(iy+plotflags)	; du graph dans backup

	LD	DE,8FF1h		; Affiche le logo 
	LD	A,38			; "DRAGON BALL Z"
defil:					; avec une animation
	PUSH	AF			; Animation de dfilement
	PUSH	DE			; Du bas de l'cran jusqu'en haut
	LD	HL,dbzlogo
	LD	BC,312
	LDIR
	CALL	_GRBUFCPY_V
	CALL	_GRBUFCLR
	POP	HL
	LD 	DE,12
	SCF
	CCF
	SBC	HL,DE
	EX 	DE,HL
	POP	AF
	DEC	A
	JP 	NZ,defil
	LD	DE,8E29h
	CALL	displaylogo			; Oblig pour la suite... !!

;	LD	DE,1E0Bh			; Version anglaise
	LD	DE,1E14h			; Lo(DE)=PENCOL (colonne)
	LD	(PENCOL),DE			; Hi(DE)=PENROW (ligne)
	SET	textInverse,(iy+textflags)	; video inverse(ON)
	LD	HL,textg.chpers			; "Choix du sayen"
	CALL	_vputs
	RES	textInverse,(iy+textflags)	; video inverse(OFF)
	CALL	afficheautaki
	LD	DE,1B50h			;
	LD	(PENCOL),DE			; Affiche la version
;	LD	HL,textg.version		; Plus besoin du fait de l'optimisation!
	CALL	_vputs
	LD	A,1
	LD	(numperso),A

menu:
	LD	DE,271Bh
	LD	A,(numperso)
	CALL	affichenomperso
	CALL	videnom		; Efface les caractres aprs le nom
menu1:
	CALL	_getkey		; Attend l'appui sur la touche
	CP	kmenup		; haut,bas, entre ou clear
	JP	Z,persprec
	CP	kmendn
	JP	Z,perssuiv
	CP	kmenclr
	RET	Z
	CP	kmenent
	JP	Z,prescombat
	JP	menu1

persprec:				; Fait dfiler le perso
	LD	A,(numperso)		; prcdent.
	DEC	A
	JP	Z,persprec1		; On est arriv au bout ?
	LD	(numperso),A
	JP	menu
persprec1:
	LD	A,5			; Alors on repart de la fin.
	LD	(numperso),A
	JP	menu

perssuiv:				; Fait dfiler le perso
	LD	A,(numperso)		; suivant.
	INC	A
	CP	6
	JP	Z,perssuiv1		; On est arriv au bout ?
	LD	(numperso),A
	JP	menu
perssuiv1:
	LD	A,1			; Alors on repart du dbut.
	LD	(numperso),A
	JP	menu

afficheautaki:
	LD	DE,3200h			; "Dragon Ball Z,
	LD	(PENCOL),DE			;  By Toriyama"
	LD	HL,textg.akira		
	CALL	_vputs			
	LD	DE,3900h			; "Dragon Ball Z83,
	LD	(PENCOL),DE			;  By A.P.S."
	CALL	_vputs
	RET

prescombat:
	LD	A,3
	LD	(senzu),A
	LD	B,A				; Animation:
prescombat1:					; clignotement nom perso.
	SET	textInverse,(iy+textflags)	; video inverse(ON)
	LD	DE,271Bh
	LD	A,(numperso)
	CALL	affichenomperso
	CALL	minitempo
	RES	textInverse,(iy+textflags)	; video inverse(OFF)
	CALL	affichenomperso
	CALL	minitempo
	DJNZ	prescombat1
	XOR	A
	LD	(ordreennemi),A
prescombat11:
	CALL	_CLRLCDFULL
	CALL	_GRBUFCPY_V
prescombat2:
	LD	A,(ordreennemi)			; A-t-on combattu tous les ennemis
	CP	4
	JP	Z,jeufini			; Oui, fin du jeu
	LD	DE,1E00h
	LD	A,(numperso)
	CALL	affichenomperso	
	CALL	ennemiparam			; enrg. nom & num ennemi
	LD	DE,2328h
	LD	(PENCOL),DE
	LD	HL,textg.vs
	SET	textInverse,(iy+textflags)	; video inverse(ON)
	CALL	_vputs				; "VS"
	RES	textInverse,(iy+textflags)	; video inverse(OFF)
	LD	DE,2A30h
	LD	A,(numennemi)
	CALL	affichenomperso			; affiche nom ennemi
	CALL	_getkey

dessindecorcombat:
	CALL	_CLRLCDFULL
	CALL	_GRBUFCLR
	LD	A,99				; vie=99
	LD	(vieperso),A
	LD	(vieennemi),A
	XOR	A				; force=0
	LD	(forceperso),A
	LD	(forceennemi),A
	LD	(actiondr),A			; Met  0 les params.
	LD	(chargedr),A			; D'action ( G & D )
	LD	(actionga),A			; d'tat de charge
	LD	(chargega),A			; et de prise.
	LD	(prisega),A
	LD	(prisedr),A
	LD	(etatdr),A			; Chaque perso est 
	LD	(etatga),A			; l'etat normal.
	LD	DE,3900h			; On affiche la vie
	LD	(PENCOL),DE			; et la force des persos
	LD	HL,textg.vie
	CALL	_vputs				; "V:"
	LD	DE,3916h
	LD	(PENCOL),DE
;	LD	HL,textg.force			; Optimis !
	CALL	_vputs				; "F:"
	LD	DE,3300h
	LD	(PENCOL),DE
	LD	HL,textg.vie
	CALL	_vputs				; "V:"
	LD	DE,3316h
	LD	(PENCOL),DE
;	LD	HL,textg.force			; Optimis!
	CALL	_vputs				; "F:"
	LD	BC,000Dh
	LD	DE,5E0Dh
	LD	H,1
	CALL	_ILINE				; Trace les
	LD	BC,2F0Ch			; cadres de
	LD	DE,2F00h			; l'affichage
	CALL	_ILINE
	LD	DE,3930h			; Affiche le nom des saiyens
	LD	A,(numennemi)			; pour le droulement
	CALL	affichenomperso			; du combat... ;)
	LD	DE,3330h
	LD	A,(numperso)			;
	CALL	affichenomperso			;
	CALL	afficheforceperso
	CALL	affichevieperso
	CALL	afficheforceennemi
	CALL	affichevieennemi
	LD	HL,0810h
	LD	(sprite.hauteur),HL
	LD	DE,bgr				; Init Coord
	LD	BC,1C1Fh			; pour
	LD	(coord.bonga),BC		; perso &
	CALL	spritegraph			; ennemi
	LD	DE,bdr				; (X,Y)
	LD	BC,421Fh
	LD	(coord.bondr),BC
	CALL	spritegraph

boucleprincipalegauche:
	CALL	_GetK
	LD	A,kleft			; appuie sur la
	CALL	_SETXXOP1		; touche gauche ?
	CALL	_CPOP1OP2
	JP	Z,gauche1
	LD	A,kdown			; appuie sur la
	CALL	_SETXXOP1		; touche bas ?
	CALL	_CPOP1OP2
	JP	Z,bas1
	LD	A,kup			; appuie sur la
	CALL	_SETXXOP1		; touche haut ?
	CALL	_CPOP1OP2
	JP	Z,haut1
	LD	A,kalpha		; appuie sur la
	CALL	_SETXXOP1		; touche ALPHA ?
	CALL	_CPOP1OP2		; (monte energie)
	JP	Z,couppoing1
	LD	A,kmode			; appuie sur la
	CALL	_SETXXOP1		; touche  MODE?
	CALL	_CPOP1OP2		; (coup de poing)
	JP	Z,changeligne
	LD	A,kvar			; appuie sur la
	CALL	_SETXXOP1		; touche X,T,Teta,n ?
	CALL	_CPOP1OP2		; (coup de pied)
	JP	Z,couppied1
	LD	A,kclear		; appuie sur la
	CALL	_SETXXOP1		; touche CLEAR ?
	CALL	_CPOP1OP2
	JP	Z,quitter1
boucleprincipalegauche1:
	LD	A,kshift		; appuie sur la
	CALL	_SETXXOP1		; touche 2ND ?
	CALL	_CPOP1OP2
	JP	Z,pouvoir1
	LD	A,kright		; appuie sur la
	CALL	_SETXXOP1		; touche droite ?
	CALL	_CPOP1OP2
	JP	Z,droite1
bouclepgadr:
	LD	A,(actionga)
	CP	1
	JP	NZ,ordi
	XOR	A
	LD	(actionga),A
	LD	BC,(coord.bonga)
	LD	DE,bgr
	CALL	spritegraph	
	JP	ordi

gauche1:
	LD	A,1			; une action
	LD	(actionga),A		; est faite
	LD	(prisega),A
	LD	A,(coord.bonga+1)
	CP	4			; bord gauche
	JP	Z,ordi			; atteint ?
	LD	BC,(coord.bonga)
	CALL	effacelignedroitebo
	DEC	B
	DEC	B
	LD	(coord.bonga),BC
	LD	DE,bgre
	CALL	spritegraph
	JP	ordi

droite1:
	LD	A,1
	LD	(actionga),A		; action faite
	LD	A,(prisega)
	CP	1
	JP	NZ,droite2
	LD	A,4
	LD	(prisega),A
	JP	droite3
droite2:
	LD	A,(prisega)
	CP	2
	JP	NZ,droite3
	INC	A
	LD	(prisega),A
droite3:
	LD	A,(coord.bonga+1)	; \
	LD	B,A			; | On peut se
	LD	A,(coord.bondr+1)	; | dplacer 
	SUB	B			; | droite ?
	CP	10			; | (d'apres bodr)
	JP	M,ordi			;/
	LD	BC,(coord.bonga)
	CALL	effacelignegauchebo
	INC	B
	INC	B
	LD	(coord.bonga),BC
	LD	DE,bgav
	CALL	spritegraph
	JP	ordi

changeligne
	CALL	changeligne1
	JP	ordi

changeligne1:
	XOR	A			; On ne fait pas d'action
	LD	(prisega),A
	LD	BC,(coord.bonga)
	CALL	spriteoff
	LD	A,(coord.bonga)
	CP	58			; Routine "bascule"
	JP	NZ,changeligne2		; Si on est en haut on va en bas
	LD	A,31			; sinon, c'est l'inverse
	JR	changeligne3
changeligne2:
	LD	A,58
changeligne3:
	LD	(coord.bonga),A
	LD	BC,(coord.bonga)
	LD	DE,bgr
	CALL	spritegraph
	RET

bas1:
	LD	A,(prisega)
	CP	1			; Est-ce qu'on prpare un super pouvoir? 
	JP	NZ,ordi			; Non
	INC	A			; Oui
	LD	(prisega),A
	LD	B,255			; On optimise la manipulation
bas2:					; Pour plus de jouabilit
	PUSH	BC
	CALL	_GetK
	LD	A,kright		; appuie sur la
	CALL	_SETXXOP1		; touche droite ?
	CALL	_CPOP1OP2
	JR	Z,bas3			; Oui
	POP	BC
	DJNZ	bas2			; non, a-t-on pass les temps coul
	JP	ordi			; Oui
bas3:
	POP	BC			; Sinon, erreur de pile
	LD	A,(prisega)
	INC	A
	LD	(prisega),A
	LD	B,255
bas4:
	PUSH	BC
	CALL	_GetK
	LD	A,kshift		; appuie sur la
	CALL	_SETXXOP1		; touche 2ND ?
	CALL	_CPOP1OP2
	JP	Z,bas5			; Oui
	POP	BC
	DJNZ 	bas4			; non, a-t-on pass les temps coul ?
	JP	ordi			; Oui
bas5:
	POP	BC			; Sinon, il y a une erreur de pile
	JP	pouvoir1

haut1:
	LD	A,(forceperso)		; On se charge en nergie,
	CP	99			; Mais, on peut en avoir 99 au maximum.
	JP	Z,ordi
	INC	A
	INC	A
	CP	100			; Il ne faut pas dpasser 99
	JR	NZ,haut2		; a cause de OP1 (0~99d)
	DEC	A
haut2:
	LD	(forceperso),A
	CALL	afficheforceperso
	LD	A,1
	LD	(actionga),A
	LD	BC,(coord.bonga)
	LD	DE,bpen
	CALL	spritegraph
	XOR	A
	LD	(prisega),A
	JP	ordi

couppoing1:
	LD	DE,bdppo		; On prpare le sprite ennemi
	LD	(bopcoup),DE		; qui prend le coup (optimisation)
	LD	BC,(coord.bonga)
	LD	A,1			; On fait une action
	LD	(actionga),A
	LD	A,(numperso)
	LD	(numsaiyen),A		; On mmorise quel sayen est le joueur
	LD	A,(prisega)		; Fait-on un coup gliss ?
	CP	4
	JR	Z,couppoing2		; Oui
	LD	DE,bgpo			; Non=>Coup de poing simple
	XOR	A
	LD	(indexcoup),A
	JP	couppres
couppoing2:
	LD	DE,bgpog		; Le perso fait un ocup gliss
	LD	A,8			; On prpare tous les paramtres
	LD	(indexcoup),A		; et on va  la routine de coups glisss
	JP	coupglisse

couppied1:
	LD	DE,bdppi		; Mme raisonnement que pour le coup de poing
	LD	(bopcoup),DE
	LD	BC,(coord.bonga)
	LD	A,1			; Fait une action
	LD	(actionga),A
	LD	A,(numperso)
	LD	(numsaiyen),A		; Quel sayen ?
	LD	A,(prisega)
	CP	4
	JR	Z,couppied2		; Coup gliss
	LD	DE,bgpi			; Coup simple
	LD	A,4
	LD	(indexcoup),A
	JP	couppres
couppied2:
	LD	DE,bgpig
	LD	A,12
	LD	(indexcoup),A
;	JP	coupglisse

coupglisse:
	PUSH	BC			; On fait un coup (poing ou pied) gliss
	PUSH	DE			; Et on mmorise les infos de sprite
	CALL	pointeurtable		; retourne le cot de la prise en fonction
	LD	A,(HL)			; du sayen
	LD	B,A
	LD	A,(forceperso)
	CP	B
	JP	M,coupglisse0		; Le coup ne peut pas se faire
	LD	A,(coord.bonga+1)	; Est-ce qu'on est assez prs 
	LD	B,A			; de l'adversaire pour faire un coup?
	LD	A,(coord.bondr+1)
	SUB	B
	CP	28
	JP	M,coupglisse1		; On peut faire le coup
coupglisse0:
	XOR	A			; Le coup gliss ne se fait pas
	LD	(prisega),A		; On fait un RAZ sur la variable de prise
	POP	DE			; Libre la mmoire
	POP	BC			; (Pour la bonne cohsion de la pile!!!)
	JP	ordi			; Passe au tour de l'ordi
coupglisse1:
	LD	L,A			;
	PUSH	HL			;
	LD	A,(forceperso)		; => Le perso perd de sa force pour
	LD	D,A			;    faire la prise
	CALL	perteenergie		;
	LD	A,D
	LD	(forceperso),A
	CALL	afficheforceperso
	XOR	A			; Vide la prise gauche
	LD	(prisega),A
	POP	HL			; On fait la prise que si
	LD	A,L			; on est sur la mme ligne
	CP	8			; que l'adversaire
	JR	Z,coupglisse3		; L, on y est pas
	POP	DE
	POP	BC
coupglisse2:
	PUSH	HL			; Fait l'animation du coup
	PUSH	DE			; gliss
	PUSH	BC
	CALL	effacelignegauchebo
	POP	BC
	INC	B
	INC	B
	POP	DE
	PUSH	BC
	PUSH	DE
	CALL	spritegraph
	POP	DE
	POP	BC
	POP	HL
	DEC	L
	DEC	L
	LD	A,L				; Jusqu' se qu'on soit prs
	CP	8				; de l'adversaire
	JR	NZ,coupglisse2
	LD	(coord.bonga),BC
	CALL	defordi				; Appel de la routine de dfense de l'odri ?
	JP	verifmortordi			; l'odri est-il mort?
coupglisse3:
	POP	DE				; Libre la mmoire
	POP	BC				; (Pour la bonne cohsion de la pile!!!)
	CALL	spritegraph
	JP	ordi

couppres:
	PUSH	BC
	XOR	A				; Vide la prise gauche
	LD	(prisega),A
	LD	A,(coord.bonga+1)
	LD	B,A
	LD	A,(coord.bondr+1)
	SUB	B
	CP	11				; Est-on assez prs de l'ordi?
	JP	P,couppres1			; Non
	POP	BC				; On se place juste  cot
	PUSH	DE
	CALL	effacelignegauchebo
	POP	DE
	LD	A,(coord.bondr+1)
	SUB	8
	LD	B,A
	LD	(coord.bonga),BC
	CALL	spritegraph
	CALL	minitempo
	CALL	defordi				; L'ordi se dfend-t-il ?
	JP	verifmortordi			; Est-il mort?
couppres1:
	POP	BC				; Pas de coup port
	CALL	spritegraph
	CALL	minitempo
	JP	ordi

pouvoir1:					; toutes les
	LD	A,(prisega)			; etiquettes
	CP	3				; 'pouvoirXX:'
	JP	NZ,pouvoir8			; concernent
	XOR	A				; la gestion
	LD	(prisega),A			; du kameha de gauche
	LD	A,(numperso)
	LD	(numsaiyen),A
	LD	A,16
	LD	(indexcoup),A
	CALL	pointeurtable
	LD	A,(HL)
	LD	B,A
	LD	A,(forceperso)
	CP	B
	JP	M,ordi		
	LD	A,1
	LD	(actionga),A
	LD	BC,(coord.bonga)
	LD	DE,(coord.bondr)
	LD	A,E
	SUB	C
	JP	Z,pouvoir12
	CALL	spriteoff
	LD	A,(coord.bondr)
	LD	C,A
	LD	(coord.bonga),BC
pouvoir12:
	LD	BC,(coord.bonga)
	LD	DE,bpen
	CALL	spritegraph
	CALL	minitempo
	LD	BC,(coord.bonga)
	PUSH	BC
	LD	DE,bgpk
	CALL	spritegraph
	LD	DE,1700h			; On va crire le nom de l'attaque
	LD	(PENCOL),DE
	LD	A,(etatga)
	LD	(etat),A
	LD	A,(numperso)
	CALL	direpouvoir
	POP	BC
	PUSH	BC
	LD	DE,bgek
	CALL	spritegraph
	LD	A,(coord.bonga+1)		; Fait le kameha
	LD	B,A				;  cot de l'ennemi ?
	LD	A,(coord.bondr+1)
	SUB	B
	CP	18
	JP	M,pouvoir6			; Oui (on ne le dessine pas)
	POP	BC				; non
	LD	A,16
	ADD	A,B
	LD	B,A
	LD	(coord.kameha),BC
	LD	BC,(coord.bonga)
	LD	A,8
	ADD	A,B
	LD	B,A
	LD	A,(etatga)			; petit ou gros
	CP	2				; kameha ?
	JP	P,pouvoir2
	CP	1
	JP	P,pouvoir2bis
	LD	DE,kameha1
	LD	(dessin.kameha),DE
	LD	DE,dekg1			; petit !
	CALL	spritegraph
	JR	pouvoir3
pouvoir2bis:
	LD	DE,kameha1
	LD	(dessin.kameha),DE
	LD	DE,dek2				; moyen !
	CALL	spritegraph
	JR	pouvoir3
pouvoir2:					; gros !!
	LD	DE,dekg3
	CALL	spritegraph
	LD	DE,kameha2
	LD	(dessin.kameha),DE
pouvoir3:					; dessine
	LD	HL,020Ch			; Kameha
	LD	(sprite.hauteur),HL		; en utilisant
	LD	BC,(coord.kameha)		; 'spritegraph'
pouvoir4:
	PUSH	BC				; avec haut=12
	LD	DE,(dessin.kameha)		; larg=2
	CALL	spritegraph
	POP	BC
	INC	B
	INC	B
	LD	A,(coord.bondr+1)
	SUB	B
	CP	1
	JP	P,pouvoir4
pouvoir5:
	LD	HL,0810h			; remet haut=16
	LD	(sprite.hauteur),HL		; larg=8 pour 'spritegraph'
	LD	DE,bdppo
	LD	(bopcoup),DE
	CALL	defordi
	LD	A,(coord.bonga)
	LD	C,A
	CALL	effacekameha
	LD	A,(forceperso)
	LD	D,A
	CALL	perteenergie			; Le kameha cote des points d'nergie
	LD	A,D
	LD	(forceperso),A
	CALL	afficheforceperso
	JP	verifmortordi
pouvoir6:
	POP	BC
	JR	pouvoir5
pouvoir8:
	LD	A,(coord.bonga+1)		; On fait une simple attaque "boule de feu"
	LD	B,A				
	LD	A,(coord.bondr+1)
	SUB	B
	CP	11				; IL faut tre assez prs de l'ordi pour cela
	JP	P,ordi				; Pas bon !
	LD	A,1				; Action faite
	LD	(actionga),A
	LD	A,(forceperso)			; Il faut avoir 1 en nergie!
	CP	1
	JP	M,ordi				; Y a pas !
	DEC	A
	LD	(forceperso),A
	CALL	afficheforceperso
	LD	BC,(coord.bonga)
	LD	DE,bgek
	CALL	spritegraph
	LD	DE,bdppo
	LD	(bopcoup),DE
	XOR	A				; Dgats causs
	LD	(indexcoup),A
	LD	BC,(coord.bondr)
	LD	A,(coord.bonga)
	SUB	C				; Les persos sont-ils sur la mme ligne?
	JP	NZ,ordi
	CALL	spriteoff
	LD	A,(coord.bondr+1)		; Comme l'attaque repousse l'adversaire,
	CP	4Ch				; il ne faut pas que l'ordi sorte de l'cran
	JP	P,pouvoir81			; par la droite!!!
	ADD	A,10				; on peut le repousser
	JR	pouvoir82
pouvoir81:
	LD	A,56h
pouvoir82:
	LD	(coord.bondr+1),A
	JP	pouvoir5

quitter1:
	LD	DE,1700h			; Met en pause le jeu
	LD	(PENCOL),DE			; et demande si on veut quitter.
	LD	HL,textg.quitter
	CALL	_vputs
	CALL	_getkey
	CP	kmenent
	JR	Z,quitter1suite
	CALL	viderlignepouvoir
	CALL	_GetK
	JP	boucleprincipalegauche1
quitter1suite:
	CALL	_CLRLCDFULL			; On quitte
	CALL	_GRBUFCLR			; efface l'cran, le buffer vido
	CALL	_runIndicOn			; remet l'indicateur de fonctionnement
	CALL	_dispDone			; et affiche "Done" !
	RET					; Retour  l'appelant.

effacekameha:
	LD	A,(coord.bonga+1)		; Efface le dessin du kameha
	ADD	A,8
	LD	B,A
	LD	DE,(coord.bondr)
	LD	E,C
	DEC	D
	LD	L,16
	LD	H,0
effacekameha1:
	CALL	_ILINE
	DEC	C
	DEC	E
	DEC	L
	JP	NZ,effacekameha1
	RET

verifmortordi:
	LD	A,(vieennemi)
	OR	A				; CP 0
	JR	Z,verifmortordi2		; l'odri est mort
	JP	ordi
verifmortordi2:
	LD	BC,(coord.bondr)		; Dessine l'ordi...
	LD	DE,bdppi
	CALL	spritegraph
	LD	BC,(coord.bonga)
	LD	DE,bgr				; ... et le perso
	CALL	spritegraph
	LD	DE,1700h			;
	LD	A,(numperso)			; => Affiche le texte
	CALL	affichenomperso			; "<Nom du sayen> gagne"
	LD	HL,caracgvide			; dans langue appropri selon la version
	CALL	_vputs			
	LD	HL,textg.gagne		
	CALL	_vputs			
	CALL	minitempo		
	CALL	minitempo		
	CALL	_getkey				; Attend l'appui sur une touche
	LD	A,(ordreennemi)			; Passe  l'ennemi suivant
	INC	A
	LD	(ordreennemi),A
	CALL	_CLRLCDFULL			; Raffiche le logo
	LD	DE,8E29h
	CALL	displaylogo
	JP	prescombat2			; et repart  la prsentation du combat

ordi:						; Jeu de l'ordi
;	JP	boucleprincipalegauche
	LD	HL,ordi.charge			; on se charge ?
	CALL	ordirand
	OR	A				; =CP 0
	JP	P,ordi2				; Ne se charge pas
	LD	A,(forceennemi)
	CP	99				; L'ordi se charge s'il n'est pas  fond
	JP	Z,boucleprincipalegauche
	INC	A
	INC	A
	CP	100
	JR	NZ,ordi0
	DEC	A
ordi0:
	LD	(forceennemi),A
	LD	BC,(coord.bondr)
	LD	DE,bpen
	CALL	spritegraph
	LD	A,1
	LD	(actiondr),A	
	CALL	afficheforceennemi
	JP	boucleprincipalegauche
ordi2:
	LD	HL,ordi.att		; L'ordi donne-t-il un coup ?
	CALL	ordirand
	OR	A			; = CP 0
	JP	P,ordi3			; NON		
	LD	A,1			; oui
	LD	(actiondr),A
	LD	A,(numennemi)
	LD	(numsaiyen),A
	LD	HL,ordi.popi		; Va-t-il donner un coup
	CALL	ordirand		; de poing ou de pied ?
	OR	A			; = Cp 0
	JP	M,ordi2pied
	LD	DE,bgppo
	LD	(bopcoup),DE
	XOR	A
	LD	(indexcoup),A
	JR	ordi21
ordi2pied:
	LD	DE,bgppi
	LD	(bopcoup),DE
	LD	A,4
	LD	(indexcoup),A
ordi21:
	LD	A,(coord.bonga+1)	; 
	LD	B,A			; Un coup prs ou gliss ?
	LD	A,(coord.bondr+1)
	SUB	B
	CP	11
	JP	P,ordi22		; un coup gliss
	LD	A,(indexcoup)		; Vrifie si c'est poing ou pied
	OR	A			; = CP 0
	JR	Z,ordi21po
	LD	DE,bdpi			; L'ordi donne un coup de pied
	JP	ordicouppres
ordi21po:
	LD	DE,bdpo
	JP	ordicouppres
ordi22:
	LD	A,(indexcoup)		; Verifie si c'est poing ou pied
	OR	A			; = CP 0
	JP	Z,ordi22po
	LD	DE,bdpig		; Coup de pied gliss
	LD	A,12
	LD	(indexcoup),A
	JP	ordicoupglisse
ordi22po:
	LD	DE,bdpog		; C'est un coup de poing gliss
	LD	A,8
	LD	(indexcoup),A
	JP	ordicoupglisse
ordi3:
	LD	HL,ordi.kam		; L'ordi fait un kameha ?
	CALL	ordirand
	OR	A			; =CP 0
	JP	P,ordi8			; NON		
	LD	A,1			; oui
	LD	(actiondr),A
	LD	A,(numennemi)
	LD	(numsaiyen),A
	JP	ordikam	
ordi8:
	LD	A,(coord.bonga+1)	; \
	LD	B,A			; | On peut se
	LD	A,(coord.bondr+1)	; | dplacer 
	SUB	B			; | gauche ?
	CP	10			; | (d'apres boga)
	JP	M,ordi9			;/  NON
	LD	HL,ordi.avance		;Oui
	CALL	ordirand
	OR	A			; = CP 0
	JP	P,ordi9
	LD	A,1			; une action
	LD	(actiondr),A		; est faite
	LD	BC,(coord.bondr)
	CALL	effacelignedroitebo
	DEC	B
	DEC	B
	LD	(coord.bondr),BC
	LD	DE,bdav
	CALL	spritegraph
	JP	boucleprincipalegauche
ordi9:
	LD	A,(coord.bondr+1)
	CP	56h			; bord droit
	JP	Z,ordi10		; atteint ?
	LD	HL,ordi.recule		; non
	CALL	ordirand
	OR	A			; = CP 0
	JP	P,ordi10
	LD	BC,(coord.bondr)
	CALL	effacelignegauchebo
	INC	B
	INC	B
	LD	(coord.bondr),BC
	LD	DE,bdre
	CALL	spritegraph
	LD	A,1			; une action
	LD	(actiondr),A		; est faite
	JP	boucleprincipalegauche

ordi10:
	LD	A,(actiondr)		; fin ordi
	CP	1
	JP	NZ,boucleprincipalegauche
	XOR	A
	LD	(actiondr),A
	LD	BC,(coord.bondr)
	LD	DE,bdr
	CALL	spritegraph	
	JP	boucleprincipalegauche

changeligneordi:
	XOR	A				; Mme principe que pour le perso
	LD	(prisedr),A
	LD	BC,(coord.bondr)
	CALL	spriteoff
	LD	A,(coord.bondr)
	CP	58
	JP	NZ,changeligneordi2
	LD	A,31
	JR	changeligneordi3
changeligneordi2:
	LD	A,58
changeligneordi3:
	LD	(coord.bondr),A
	LD	BC,(coord.bondr)
	LD	DE,bdr
	CALL	spritegraph
	RET

ordirand:
	LD	B,20			; Renvoi un chiffre au pif!
	CALL	rand
	LD	C,A
	CALL	ordicommande
	SUB	C
	RET

ordicommande:
	LD	A,(numennemi)		; HL: Entre
	DEC	A
	LD	B,A
ordicommande2:
	INC	HL			; A:sortie
	DJNZ	ordicommande2
	LD	A,(HL)
	RET

ordicouppres:
	LD	A,(coord.bondr)		; On va donner un coup prs du perso
	LD	B,A
	LD	A,(coord.bonga)
	SUB	B
	JR	Z,ordicouppres1
	CALL	changeligneordi		; L'odri n'est pas sur la mme ligne que
	JP	boucleprincipalegauche	; le perso: on change de ligne!
ordicouppres1:
	LD	BC,(coord.bondr)
	PUSH	DE
	CALL	effacelignedroitebo
	POP	DE
	LD	A,(coord.bonga+1)
	ADD	A,8
	LD	B,A
	LD	(coord.bondr),BC
	CALL	spritegraph
	CALL	minitempo
	CALL	defpersosimple
	JP	verifmortperso	

ordicoupglisse:
	LD	BC,(coord.bondr)		; L'ordi fait un coup (poing ou pied) gliss
	PUSH	BC
	PUSH	DE
	CALL	pointeurtable
	LD	A,(HL)
	LD	B,A
	LD	A,(forceennemi)
	CP	B
	JP	M,ordicoupglisse0
	LD	A,(coord.bonga+1)		; Vrifie si l'ordi n'est pas trop loin
	LD	B,A				; du perso pour faire la prise
	LD	A,(coord.bondr+1)
	SUB	B
	CP	28
	JP	M,ordicoupglisse1		; L'ordi est trop loin. on reviendra !!
ordicoupglisse0:
	POP	DE
	POP	BC
	JP	boucleprincipalegauche
ordicoupglisse1:				; Voir commentaire sur le perso
	LD	L,A
	PUSH	HL
	LD	A,(forceennemi)
	LD	D,A
	CALL	perteenergie
	LD	A,D
	LD	(forceennemi),A
	CALL	afficheforceennemi
	POP	HL
	LD	A,L
	CP	8
	JR	Z,ordicoupglisse3
	POP	DE
	POP	BC
ordicoupglisse2:
	PUSH	HL
	PUSH	DE
	PUSH	BC
	CALL	effacelignedroitebo
	POP	BC
	DEC	B
	DEC	B
	POP	DE
	PUSH	BC
	PUSH	DE
	CALL	spritegraph
	POP	DE
	POP	BC
	POP	HL
	DEC	L
	DEC	L
	LD	A,L
	CP	8
	JR	NZ,ordicoupglisse2
	LD	(coord.bondr),BC
	CALL	defpersosimple
	JP	verifmortperso
ordicoupglisse3:
	POP	DE
	POP	BC
	CALL	spritegraph
	JP	boucleprincipalegauche

ordikam:
	LD	A,16			; L'ordi fait un super pouvoir
	LD	(indexcoup),A		; Voir les commentaires sur le perso
	CALL	pointeurtable
	LD	A,(HL)
	LD	B,A
	LD	A,(forceennemi)
	LD	(forceennemi),A
	CP	B
	JP	M,boucleprincipalegauche
	LD	BC,(coord.bondr)
	LD	DE,(coord.bonga)
	LD	A,E
	SUB	C
	JR	Z,ordikam12
	CALL	spriteoff
	LD	A,(coord.bonga)
	LD	(coord.bondr),A
ordikam12:
	LD	BC,(coord.bondr)
	LD	DE,bpen
	CALL	spritegraph
	CALL	minitempo
	LD	BC,(coord.bondr)
	PUSH	BC
	LD	DE,bdpk
	CALL	spritegraph
	LD	DE,1726h
	LD	(PENCOL),DE
	LD	A,(etatdr)
	LD	(etat),A
	LD	A,(numennemi)
	CALL	direpouvoir
	POP	BC
	PUSH	BC
	LD	DE,bdek
	CALL	spritegraph
	LD	A,(coord.bonga+1)		; Fait le kameha
	LD	B,A				;  cot de l'ennemi ?
	LD	A,(coord.bondr+1)
	SUB	B
	CP	18
	JP	M,ordikam6			; Oui
	POP	BC				; non
	LD	A,B
	SUB	10
	LD	B,A
	LD	(coord.kameha),BC
	LD	BC,(coord.bondr)
	LD	A,B
	SUB	8
	LD	B,A
	LD	A,(etatdr)			; petit ou gros
	CP	2				; kameha ?
	JP	P,ordikam2
	CP	1
	JP	P,ordikam2bis
	LD	DE,kameha1
	LD	(dessin.kameha),DE
	LD	DE,dekd1			; petit !
	CALL	spritegraph
	JR	ordikam3
ordikam2bis:
	LD	DE,kameha1
	LD	(dessin.kameha),DE
	LD	DE,dek2				; moyen !
	CALL	spritegraph
	JR	ordikam3
ordikam2:					; gros !!
	LD	DE,dekd3
	CALL	spritegraph
	LD	DE,kameha2
	LD	(dessin.kameha),DE
ordikam3:					; dessine
	LD	HL,020Ch			; Kameha
	LD	(sprite.hauteur),HL		; en utilisant
	LD	BC,(coord.kameha)		; 'spritegraph'
ordikam4:
	PUSH	BC				; avec haut=12
	LD	DE,(dessin.kameha)		; larg=2
	CALL	spritegraph
	POP	BC
	DEC	B
	DEC	B
	LD	A,(coord.bonga+1)
	ADD	A,8
	SUB	B
	CP	1
	JP	M,ordikam4
ordikam5:
	LD	HL,0810h			; remet haut=16
	LD	(sprite.hauteur),HL		; larg=8 pour 'spritegraph'
	LD	DE,bgppo
	LD	(bopcoup),DE
	CALL	defpersosimple
	LD	A,(coord.bondr)
	LD	C,A
	CALL	effacekameha
	LD	A,(forceennemi)
	LD	D,A
	CALL	perteenergie
	LD	A,D
	LD	(forceennemi),A
	CALL	afficheforceennemi
	JP	verifmortperso
ordikam6:
	POP	BC
	JR	ordikam5
ordikam8:
	LD	A,(coord.bonga+1)
	LD	B,A
	LD	A,(coord.bondr+1)
	SUB	B
	CP	11
	JP	P,boucleprincipalegauche
	LD	A,(forceennemi)
	CP	1
	JP	M,boucleprincipalegauche
	DEC	A
	LD	(forceennemi),A
	CALL	afficheforceennemi
	LD	BC,(coord.bondr)
	LD	DE,bdek
	CALL	spritegraph
	LD	DE,bgppo
	LD	(bopcoup),DE
	XOR	A
	LD	(indexcoup),A
	LD	BC,(coord.bondr)
	LD	A,(coord.bonga)
	SUB	C
	JP	NZ,boucleprincipalegauche
	CALL	spriteoff
	LD	A,(coord.bonga+1)
	CP	0Ah
	JP	P,ordikam81
	SUB	10
	JR	ordikam82
ordikam81:
	XOR	A
ordikam82:
	LD	(coord.bonga+1),A
	JP	ordikam5

defpersosimple:
	LD	A,(coord.bondr)		; Si le perso n'est pas sur
	LD	B,A			; la mme ligne que l'ennemi
	LD	A,(coord.bonga)		; alors, y a rien  faire:
	SUB	B			; on sort
	RET	NZ
	LD	A,(vieperso)
	LD	(vie),A
	CALL	_GetK
	LD	A,kleft			; appuie sur la
	CALL	_SETXXOP1		; touche gauche ?
	CALL	_CPOP1OP2
	JR	Z,defpersosimpleprot	;Alors se protege
	LD	A,kmode			; Appuie sur MODE?
	CALL	_SETXXOP1
	CALL	_CPOP1OP2
	JR	Z,defpersosimpleesquive	; Alors esquive totale
	LD	BC,(coord.bonga)	; Sinon se prend tout
	LD	DE,(bopcoup)
	CALL	spritegraph
	CALL	minitempo
	XOR	A
	LD	(data+1),A
	INC	A
	LD	(actionga),A
	JR	defpersosimplevie
defpersosimpleprot:
	LD	BC,(coord.bonga)
	LD	DE,bgpr
	CALL	spritegraph
	CALL	minitempo
	LD	A,1
	LD	(data+1),A
	LD	(actionga),A
defpersosimplevie
	LD	A,(etatdr)
	LD	(etat),A
	CALL	diffetatdr
	CALL	pertevie
	LD	A,(vie)
	LD	(vieperso),A
	CALL	affichevieperso
	RET	
defpersosimpleesquive:
	CALL	changeligne1
	RET

verifmortperso:
	LD	A,(vieperso)
	OR	A				; = CP 0
	JR	Z,verifmortperso2
	JP	boucleprincipalegauche
verifmortperso2:
	LD	BC,(coord.bonga)		; Le joueur a perdu!
	LD	DE,bgppo
	CALL	spritegraph
	LD	BC,(coord.bondr)
	LD	DE,bdr
	CALL	spritegraph
	LD	DE,1700h
	LD	A,(numperso)
	CALL	affichenomperso
	LD	HL,caracgvide
	CALL	_vputs
	LD	HL,textg.perd
	CALL	_vputs
	CALL	minitempo
	CALL	_getkey
	CALL	_CLRLCDFULL
	LD	DE,8E29h
	CALL	displaylogo
	LD	DE,2010h
	LD	(PENCOL),DE	
	LD	HL,textg.senzu
	CALL	_vputs
	LD	A,(senzu)
	OR	A				; = CP 0
	JR	Z,gameover
	LD	HL,textg.senzu
	LD	A,(senzu)		
	CALL	_SETXXOP1			; affiche Nbre de senzus
	LD	A,1				; sur 1 digit
	CALL	_DISPOP1A
	LD	DE,3815h
	LD	(PENCOL),DE
	LD	HL,textg.continue
	CALL	_vputs
	CALL	_getkey
	CP	kmenent
	JR	Z,verifmortperso3

gameover:
	LD	DE,281Bh
	LD	(PENCOL),DE
	LD	HL,textg.gameover
	SET	textInverse,(iy+textflags)	; video inverse(ON)
	CALL	_vputs
	RES	textInverse,(iy+textflags)	; video inverse(OFF)
	CALL	minitempo
	CALL	minitempo	
	CALL	_getkey
	JP	debut	
verifmortperso3:
	LD	A,(senzu)
	DEC	A
	LD	(senzu),A
	JP	prescombat11

effacelignedroitebo:
	PUSH	BC
	LD	A,B			; rcupre X
	LD	B,6			; calcule
	ADD	A,B			; le bas du
	LD	B,A			; sprite
	LD	E,16			;
	LD	A,C			; rcupre Y
	SUB	E			; trace 2 lignes
	LD	E,A			; qui efface
	LD	D,B			;  droite du
	LD	H,0			; sprite
	CALL	_ILINE		;
	INC	B
	INC	D
	CALL	_ILINE
	POP BC
	RET
	
effacelignegauchebo:
	PUSH	BC		; Similaire comme pour la droite
	LD	D,B
	LD	A,C
	LD	E,16
	SUB	E
	LD	E,A
	LD	H,0
	CALL	_ILINE
	INC	B
	INC	D
	CALL	_ILINE
	POP	BC
	RET

forcepersomoins:
	LD	A,(forceperso)
	SUB	B
	LD	(forceperso),A
	CALL	afficheforceperso
	RET

afficheforceperso:
	LD	A,(forceperso)
	LD	B,A
	PUSH	BC				; Le S/P "energie" a besoin de B...
	LD	A,51
	CALL	afficheforce
	LD	DE,3330h
	LD	(PENCOL),DE
	LD	A,(numperso)
	POP	BC				; ... donc, on le lui donne!!!
	CALL	energie
	LD	(etatga),A
	RET

affichevieperso:
	LD	A,(vieperso)
	OR	A				; = CP 0
	JP	P,affichevieperso2
	XOR	A				; Pour viter d'afficher des valeurs ngatives
	LD	(vieperso),A
affichevieperso2:
	LD	B,A
	LD	A,51				; pour l'optimisation, donne la coord. X
	CALL	affichevie
	RET

afficheforceennemi:
	LD	A,(forceennemi)
	LD	B,A
	PUSH	BC				; idem que 'afficheforceperso'
	LD	A,57
	CALL	afficheforce
	LD	DE,3930h
	LD	(PENCOL),DE
	LD	A,(numennemi)
	POP	BC				; ... jusqu'au bout !!!
	CALL	energie
	LD	(etatdr),A
	RET

affichevieennemi:
	LD	A,(vieennemi)
	OR	A				; = CP 0
	JP	P,afficheviennemi2
	XOR	A
	LD	(vieennemi),A
afficheviennemi2:
	LD	B,A
	LD	A,57
	CALL	affichevie
	RET

afficheforce:
	LD	(PENROW),A			; A contient la ligne (donc le perso)
	LD	A,29				; o affiche la force
	LD	(PENCOL),A
	LD	A,B				; B contient La force en question
	CALL	_SETXXOP1			; Affiche la
	LD	A,3				; force sur 
	CALL	_DISPOP1A			; 3 digits
	LD	HL,caracgvide
	CALL	_vputs
	RET

affichevie:
	LD	(PENROW),A			; Mme principe que afficheforce
	LD	A,7
	LD	(PENCOL),A
	LD	A,B
	CALL	_SETXXOP1
	LD	A,2				; idem pour
	CALL	_DISPOP1A			; la vie
	LD	HL,caracgvide
	CALL	_vputs
	RET

energie:				; Affiche le nom du perso ou son tat selon sa force
	PUSH	AF
	LD	A,B			; Compare suivant la force contenue dans B
	CP	75
	JP	P,energie2
	CP	50
	JP	P,energie3
	CP	25
	JP	P,energie4
	POP	AF
	CALL	affichenomperso	
	CALL	videnom		
	XOR	A
	RET
energie4:
	LD	HL,textg.supersaiyen
	CALL	_vputs
	LD	HL,caracgvide
	CALL	_vputs
	POP	AF
	LD	A,1
	RET
energie3:
	LD	HL,textg.megasaiyen
	CALL	_vputs
	LD	HL,caracgvide	
	CALL	_vputs
	POP	AF
	LD	A,2
	RET
energie2:
	LD	HL,textg.hypersaiyen
	CALL	_vputs
	POP	AF
	LD	A,3
	RET

perteenergie:
	CALL	pointeurtable
	LD	A,(HL)
	LD	B,A
	LD	A,D				; D contient la force de dpart
	SUB	B
	LD	D,A				; il contient aussi le rsultat!
	RET

pointeurtable:
	LD	A,(numsaiyen)		; retourne dans HL
	CP	1			; l'adresse qui contient la valeur de perte
	CALL	Z,gokuperte		; d'aprs le nom du perso et le coup port.
	CP	2
	CALL	Z,gohanperte
	CP	3
	CALL	Z,gothenperte
	CP	4
	CALL	Z,vegetaperte
	CP	5
	CALL	Z,trunksperte
	LD	A,(indexcoup)
	LD	C,A
	LD	B,00
	ADD	HL,BC
	RET
gokuperte:
	LD	HL,perte.goku
	RET
gohanperte:
	LD	HL,perte.gohan
	RET
gothenperte:
	LD	HL,perte.gothen
	RET
vegetaperte:
	LD	HL,perte.vegeta
	RET
trunksperte:
	LD	HL,perte.trunks
	RET

diffetatga:
	LD	A,(etatdr)	; Donne la diffrence des tats, perso/ordi
	LD	B,A
	LD	A,(etatga)
	SUB	B
	LD	(data),A
	RET
diffetatdr:
	LD	A,(etatga)	; Donne la diffrence des tats, ordi/perso
	LD	B,A
	LD	A,(etatdr)
	SUB	B
	LD	(data),A
	RET

pertevie:
	CALL	pointeurtable
	LD	A,(data+1)		; dpend de la protection de l'ordi
	OR	A			; = CP 0			
	JR	Z,pertetout		; L'ordi ne se protege pas
	LD	A,(data)		; L'ordi se protge
	OR	A			; = CP 0
	JR	Z,pertemoitie		; Force.ordi=force.perso
	JP	M,perteun		; force.ordi>force.perso
	LD	A,(data)		; force.ordi<force.perso
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	A,(HL)
	JR	pertevie3
perteun:
	LD	A,1
	JR	pertevie3
pertetout:
	CALL	perteetat
	JR	pertevie3
pertemoitie:
	CALL	perteetat
	SRL	A			; Divise par 2
pertevie3:
	LD	B,A
	LD	A,(vie)
	SUB	B
	LD	(vie),A
	RET
perteetat:
	LD	A,(etat)
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	A,(HL)
	RET

defordi:
	LD	A,(coord.bondr)		; Si le perso n'est pas sur
	LD	B,A			; la mme ligne que l'ennemi
	LD	A,(coord.bonga)		; alors, y a rien  faire:
	SUB	B			; on sort
	RET	NZ
	LD	A,(vieennemi)
	LD	(vie),A
	LD	HL,ordi.prot
	CALL	ordirand
	SUB	C
	CP	1
	JP	P,defordipasdef
	LD	HL,ordi.prot
	CALL	ordirand
	SUB	C
	CP	1
	JP	P,defordiparer
	CALL	changeligneordi
	RET
defordiparer
	LD	BC,(coord.bondr)
	LD	DE,bdpr
	CALL	spritegraph
	CALL	minitempo
	LD	A,1
	LD	(data+1),A
	LD	(actiondr),A
	JR	defordivie
defordipasdef:
	LD	BC,(coord.bondr)
	LD	DE,(bopcoup)
	CALL	spritegraph
	CALL	minitempo
	XOR	A
	LD	(data+1),A
	INC	A
	LD	(actiondr),A
defordivie:
	LD	A,(etatga)
	LD	(etat),A
	CALL	diffetatga
	CALL	pertevie
	LD	A,(vie)
	LD	(vieennemi),A
	CALL	affichevieennemi
	RET

minitempo:
	PUSH	BC
	LD	B,255
minitempo1:
	LD	C,255
minitempo2:
	DEC	C
	JR	NZ,minitempo2
	DEC	B
	JR	NZ,minitempo1
	POP	BC
	RET

ennemiparam:
	LD	A,(numperso)		; Donne l'ordre d'affrontement des persos
	CP	1			; selon le hros choisi.
	JR	Z,ennemigoku
	CP	2
	JR	Z,ennemigohan
	CP	3
	JR	Z,ennemigothen
	CP	4
	JR	Z,ennemivegeta
	CP	5
	JR	Z,ennemitrunks
	RET
ennemigoku:
	LD	HL,combatgoku
	JR	ennemiparam1	
ennemigohan:
	LD	HL,combatgohan
	JR	ennemiparam1	
ennemigothen:
	LD	HL,combatgothen
	JR	ennemiparam1
ennemivegeta:
	LD	HL,combatvegeta
	JR	ennemiparam1
ennemitrunks:
	LD	HL,combattrunks
ennemiparam1:
	LD	A,(ordreennemi)
	LD	C,A
	LD	B,00
	ADD	HL,BC
	LD	A,(HL)
	LD	(numennemi),A
	RET
	
spritegraph:
	LD	A,(sprite.hauteur)	; Routine d'affichage de sprite
contline:	
	PUSH	AF			; avec hauteur et largeur variables
	PUSH	BC			; DE= adresse du sprite en mmoire
	LD	A,(sprite.largeur)	; BC= coords du sprtie  l'cran
	LD	H,A
	LD	A,(DE)
contcol:	
	PUSH	DE
	RLCA
	JR	C,pointon
	LD	D,0
	JR	suite
pointon:
	LD	D,1
suite:		
	CALL	_IPOINT
	POP	DE
	INC	B
	DEC	H
	JR	NZ,contcol
	INC	DE
	POP	BC
	DEC	C
	POP	AF
	DEC	A
	JR	NZ,contline
	RET

spriteoff:
	PUSH	BC		; Efface un sprite selon ses coordonnes
	PUSH	DE	
	LD	D,B
	LD	A,C
	LD	E,16
	SUB	E
	LD	E,A
	LD	A,8
	LD	H,0
spriteoff2:
	CALL	_ILINE
	INC	B
	INC	D
	DEC	A
	JP	NZ,spriteoff2
	POP	DE
	POP	BC
	RET

displaylogo:
	PUSH	DE				; Affiche le logo
	CALL	_GRBUFCLR
	POP	DE
	LD	HL,dbzlogo
	LD	BC,312
	LDIR
	CALL	_GRBUFCPY_V
	RET

affichenomperso:
	LD	(PENCOL),DE			; Necessite le N de perso dans A
	CP	1
	CALL	Z,affichegoku
	CP	2
	CALL	Z,affichegohan
	CP	3
	CALL	Z,affichegoten
	CP	4
	CALL	Z,affichevegeta
	CP	5
	CALL	Z,affichetrunks
	CALL	_vputs
	RET
affichegoku:
	LD	HL,textg.songoku
	RET
affichegohan:
	LD	HL,textg.songohan
	RET
affichegoten:
	LD	HL,textg.songoten
	RET
affichevegeta:
	LD	HL,textg.vegeta
	RET
affichetrunks:
	LD	HL,textg.trunks
	RET

videnom:
	LD	B,5
videnom1:
	LD	HL,caracgvide
	CALL	_vputs
	DJNZ	videnom1
	RET

direpouvoir:
	CP	1			; Ecrit le nom de l'attaque d'aprs le perso
	JR	Z,pouvoirgoku
	CP	2
	JR	Z,pouvoirgohan
	CP	3
	JR	Z,pouvoirkam		;  la fin de DBZ, Goten ne veut pas ?
	CP	4			; ne sait plus ? se battre. Donc, il
	JR	Z,pouvoirvegeta		; ne connait que le kamehameha !
	CP	5			; Dites-le moi si je me trompe !
	JR	Z,pouvoirtrunks
	RET
pouvoirgoku:
	LD	A,(etat)
	CP	2
	JP	P,pouvoirgoku2
pouvoirkam:
	LD	HL,kamehameha
	LD	B,5			; Nbre de syllabes.
	JR	direpouvoir1
pouvoirgoku2:
	LD	HL,megahameha
	LD	B,5			; Nbre de syllabes.
	JR	direpouvoir1
pouvoirgohan:
	LD	A,(etat)
	CP	2
	JP	P,pouvoirkam
	LD	HL,masenko
	LD	B,3			; Nbre de syllabes.
	JR	direpouvoir1
pouvoirvegeta:
	LD	A,(etat)
	CP	2
	JP	P,pouvoirvegeta2
	LD	HL,bigbang
	LD	B,4			; Nbre de syllabes.
	JR	direpouvoir1
pouvoirvegeta2:
	LD	hl,finalflash
	LD	B,3
	JR	direpouvoir1
pouvoirtrunks:
	LD	A,(etat)
	CP	2
	JP	P,pouvoirtrunks2
	LD	HL,kiaho
	LD	B,3			; Nbre de syllabes.
	JR	direpouvoir1
pouvoirtrunks2:
	LD	HL,kikoha
	LD	B,3
direpouvoir1:
	CALL	_vputs
	CALL	minitempo
	DJNZ	direpouvoir1
	CALL	minitempo
	CALL	viderlignepouvoir
	RET

viderlignepouvoir:		; Efface la ligne o s'crit le pouvoir
	LD	DE,1700h
	LD	(PENCOL),DE
	LD	B,24
viderlignepouvoir1:
	LD	HL,caracgvide
	CALL	_vputs
	DJNZ	viderlignepouvoir1
	RET

;---------= Random number generator =---------
; C'est pas une routine  moi !
; MERCI A NEOROUTINE ET A SES AUTEURS !!
; input b=upper bound
; ouput a=answer 0<=a<b

rand:	ld	hl,(data)
	ld	a,r
	ld	d,a
	ld	e,(hl)
	add	hl,de
	add	a,l
	xor	h
	ld	(data),hl
	ld	hl,0
	ld	e,a
	ld	d,h
randl:	add	hl,de
	djnz	randl
	ld	a,h
nomore:	ret

;*-----------------------------------

jeufini:				; Fin du jeu
	RES	plotdisp,(iy+plotflags)	; permet la sauvegarde
	RES	plotloc,(iy+plotflags)	; du graph dans backup
	SET	TEXTWRITE,(iy+SGRFLAGS)	; Permet d'crire le text dans display ET dans grpah buffer
	CALL	_CLRLCDFULL		
	LD	DE,8E29h
	CALL	displaylogo
	CALL	minitempo
	LD	DE,250Ah
	LD	A,(numperso)
	CALL	affichenomperso
	LD	HL,textg.vainqueur
	CALL	_vputs
	CALL	afficheautaki
	CALL	_GRBUFCPY_V
	CALL	minitempo
	CALL	_getkey
	LD	A,64
	LD	(senzu),A		; Rutilise une variable pour viter
	CALL	rotationlogo		; d'en crer une nouvelle
	CALL	_getkey
	LD	DE,8E29h
	CALL	displaylogo		; Vide l'cran et le buffer video et raffiche le logo
	LD	DE,1C00h
	LD	(PENCOL),DE
	LD	HL,textg.mail1
	CALL	_vputs
	LD	DE,2420h
	LD	(PENCOL),DE
	CALL	_vputs
	LD	DE,2C00h
	LD	(PENCOL),DE
	LD	HL,textg.tori
	CALL	_vputs
	LD	DE,3420h
	LD	(PENCOL),DE
	CALL	_vputs
	CALL	_GRBUFCPY_V
	CALL	_getkey
jeufini1:
	LD	A,26
	LD	(senzu),A
	CALL	rotationlogo
	CALL	_GetK
	LD	A,kclear		; appuie sur la
	CALL	_SETXXOP1		; touche clear pour quitter
	CALL	_CPOP1OP2		; (Faut la trouver... ;) )
	JR	NZ,jeufini1

	RET

rotationlogo:
	LD	DE,8E29h	; ces 4 lignes permettent de recopier
	LD	HL,dbzlogo	; les octets se trouvant  "logo"
	LD	BC,312		;  l'adresse 8E29h, dbut de la zone
	LDIR			; "graph buffer". Grce  LDIR.
	CALL	_GRBUFCPY_V	; Recopie le graph buffer  l'cran
	LD	C,94		; Nb de colonne  faire tourner(Ecran total)
entier:			
	LD	A,(senzu)	; Nb de ligne  faire tourner
	LD	B,A
	LD	HL,8E29h	;
	LD	(data),HL	; On mmorise le dbut de la zone  faire tourner
ligne:
	LD	HL,(data)	; on rcupre le dbut de la ligne  faire tourner
	LD	DE,11		; puis on calcule la fin de celle-ci 
	ADD	HL,DE		; (une ligne fait 12 octets)
	PUSH	HL		; Mmorise le rsultat dans la pile
	LD	HL,(data)	; On reprend le dbut de la ligne
	SCF			; pour dterminer si le bit le + 
	LD	A,(HL)		; gauche est  1 ou 0
	AND	10000000b	; Ce bit est stock dans le bit retenu(carry)
	JR	Z,carry	; 
	CCF			;
carry:
	POP	HL		; On rcupre l'octet de la fin de la ligne
	LD	A,12		; il y a 12 octets sur une ligne
loop:
	RL	(HL)		; on fait un "rotate left" rotation  gauche
	DEC	HL		; de l'octet point par HL. la carry va dans b0 et
	DEC	A		; le b7 va dans la carry. -> pour l'octet suivant
	JR	NZ,loop		; on recule HL (vers dbut de ligne) et on boucle pour 12 octets
	LD	HL,(data)	; >on calcule la ligne suivante
	LD	DE,12		; >et on mmorise le resultat
	ADD	HL,DE		; >cette partie peut tre amliore
	LD	(data),HL	; >
	DJNZ	ligne		; Si on n'a pas fait les 26 lignes, on recommence pour les suivantes.
	PUSH	BC		; <- Est-ce ncessaire?
	CALL	_GRBUFCPY_V	; Une fois que le sprite  tourn en entier, on l'affiche
	POP	BC		; <- Est-ce ncessaire?
	DEC	C		; Est-ce qu'on a fait tourner le sprite du nombre de bit voulu?
	JR	NZ,entier	; Non, on boucle
	RET			; Le sprite a tourn, c'est fini et on en a mis plein les yeux!


; ----------------------------------------
; --		VARIABLES		--
; ----------------------------------------

data:
	.db	00,00

combatgoku:
	.db	2,3,5,4 	; Ordre de passage des ennemi
				; Selon le perso choisi
combatgohan:			; au dpart.
	.db	3,5,4,1		; L'ordre des persos est respect
				; Ex: on choisi Goku,
combatgothen:			; On va se battre contre:
	.db	5,2,4,1		; Gohan, Goten, Trunks puis Vegeta.
				; Etc...
combatvegeta:
	.db	5,3,2,1

combattrunks:
	.db	3,4,2,1


perte.goku:
	.db	1,2,3,5,2,3,4,6,3,4,5,7,4,5,6,8,10,13,16,20	
	;	|	  |	    |		;Ici c'est l'efficacit
						;des coups ports.
perte.gohan:
	.db	1,2,3,6,2,3,4,6,3,4,5,8,4,5,6,8,10,12,15,21	
						; ca se lit comme ca:
						; coup poing normal,
perte.gothen:					; coup poing Sp.saiyen
	.db	1,2,3,4,1,2,3,6,2,3,4,5,3,4,5,8,10,13,15,19	
						; coup poing Sp.saiyen2
						; coup poing Sp.saiyen3
perte.vegeta:					; coup pied normal...
	.db	2,3,4,6,1,2,3,5,4,5,6,8,3,4,5,7,10,12,16,19	
						; coup poing glisse...
						; coup pied glisee...
perte.trunks:
	.db	1,2,3,4,1,2,3,6,3,4,5,6,3,4,5,7,10,13,16,19
						; Kameha normal...

; --	Donnes pour le jeu de l'ordi	--

ordi.charge:
	.db	5,10,15,20,25	; Ici, c'est les ractions
				; de l'ordi.
ordi.avance:			; C'est des "pourcentages"
	.db	10,15,10,10,10	; de russite.
				; le 1er Num, c'est pour Goku,
ordi.recule:			; le 2e Gohan, le 3e Goten...
	.db	10,10,15,10,8	; plus c'est grand, plus l'ordi a 
				; de chance de le faire.
ordi.prot:
	.db	10,8,15,12,5

ordi.att:
	.db	14,12,10,16,13	; L'ordi attaque (coup poing/pied...)

ordi.kam:
	.db	4,4,2,5,3	; L'ordi fait des attaques spciales

ordi.popi:
	.db	15,12,10,5,8	; L'ordi attque au pied, au poing ?
				; Si <, alors attaque au pied
; ------------------------------------------------
; --		TEXTES et COORDONNEES		--
; ------------------------------------------------

Description:
	.db	"DBZ83, La bataille Saiyenne",0	; pour ASHELL
;	.db	"DBZ83, The Saiyan Battle",0	; pour ASHELL (Version anglaise)

Icone:
	.db	00000000b
	.db	00111111b
	.db	00110011b
	.db	00100110b
	.db	00001100b
	.db	00011001b
	.db	00110011b
	.db	00111111b

textg.chpers:
	.db	"Choix du saiyen",0
;	.db	"Choose your saiyan",0		; Version anglaise

textg.akira:
	.db	"Dragon Ball Z, A. Toriyama",0

textg.auteur:
	.db	"Dragon Ball Z83, By A.P.S.",0

textg.version:
	.db	"V0.5",0

textg.songoku:
	.db	"SON GOKU",0

textg.songohan:
	.db	"SON GOHAN",0

textg.songoten:
	.db	"SON GOTEN",0

textg.vegeta:
	.db	"VEGETA",0
;	.db	"VEGITA",0			; Version anglaise

textg.trunks:
	.db	"TRUNKS",0

textg.supersaiyen:
	.db	"SUPER SAIYEN   ",0
;	.db	"SUPER SAIYAN   ",0		; Version anglaise

textg.megasaiyen:
	.db	"SUP. SAIYEN2",0
;	.db	"SUP. SAIYAN2",0		; Version anglaise

textg.hypersaiyen:
	.db	"SUP. SAIYEN3",0
;	.db	"SUP. SAIYAN3",0		; Version anglaise

textg.vs:
	.db	"VS",0

textg.vie:
	.db	"V:",0

textg.force:
	.db	"F:",0

caracgvide:
	.db	"    ",0

textg.quitter:
	.db	"Confirmez!(Enter)",0
;	.db	"Confirm!(Enter)",0		; Version anglaise

textg.gagne:
	.db	"GAGNE !!!",0
;	.db	"WIN !!!",0			; Version anglaise

textg.perd:
	.db	"PERD...",0
;	.db	"LOSE...",0			; Version anglaise

textg.senzu:
	.db	"SENZU(S) :",0

textg.gameover:
	.db	"Game Over",0

textg.vainqueur:
	.db	"  Vainqueur !!!!",0
;	.db	"  Champion !!!!",0		; Version anglaise

textg.mail1:
	.db	"E-Mail Auteur du prog.:",0
;	.db	"E-Mail Author of prog.:",0	;Version anglaise
	.db	"kameha@voila.fr",0

textg.tori:
	.db	"Tous droits reserves a",0
;	.db	"All rights reserved to",0	; Version anglaise
	.db	"Akira Toriyama",0

textg.continue:
	.db	"Enter=Continuer",0
;	.db	"Enter=Continue",0		; Version anglaise

kamehameha:
	.db	"KA",0,"ME",0,"HA",0,"ME",0,"HA",0

megahameha:
	.db	"ME",0,"GA",0,"HA",0,"ME",0,"HA",0
;	.db	"ME",0,"GA ",0," KAMEHA",0,"ME",0,"HA",0	;Version anglaise

masenko:
	.db	"MA",0,"SEN",0,"KO",0

bigbang:
	.db	"BIG ",0," BANG ",0," ATT",0,"ACK",0

finalflash:
	.db	"FI",0,"NAL ",0," FLASH",0

kiaho:
	.db	"KI",0,"AI",0,"HO",0

kikoha:
	.db	"KI",0,"KO",0,"HA",0

; ----------------------------------------
; --		GRAPHISMES		--
; ----------------------------------------

bgr:	
	.db	00011000b
	.db	00011000b
	.db	00011000b
	.db	00011000b
	.db	00010000b
	.db	00111000b
	.db	01010100b
	.db	01010100b
	.db	00010000b
	.db	00101000b
	.db	00101000b
	.db	00101000b
	.db	01000100b
	.db	01000100b
	.db	01000100b
	.db	01000100b

bdr:
	.db	24,24,24,24,8,28,42,42
	.db	8,20,20,20,34,34,34,34

bgm:
	.db	24,24,24,24,24,8,28,42,42
	.db	8,20,20,20,20,20,20,20,20

bdm:
	.db	24,24,24,24,16,56,84,84
	.db	16,40,40,40,40,40,40,40

bgav:
	.db	00000110b
	.db	00000110b
	.db	00000110b
	.db	00000110b
	.db	00000100b
	.db	00011110b
	.db	00101001b
	.db	01001000b
	.db	00011100b
	.db	00010100b
	.db	00100100b
	.db	00100100b
	.db	01001000b
	.db	01001000b
	.db	10010000b
	.db	10000000b

bdav:
	.db	96,96,96,96,32,120,148,148
	.db	56,40,36,36,18,18,9,1

bgre:
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00100000b
	.db	01111000b
	.db	10010100b
	.db	01010010b
	.db	00111000b
	.db	00101000b
	.db	00100100b
	.db	00100100b
	.db	00010010b
	.db	00010010b
	.db	00001001b
	.db	00000001b

bdre:
	.db	12,12,12,12,4,30,41,74
	.db	28,20,36,36,72,72,144,128

bgpo:	
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001000b
	.db	00111111b
	.db	01001000b
	.db	00101000b
	.db	00001000b
	.db	00011100b
	.db	00010100b
	.db	00010100b
	.db	00100100b
	.db	00100100b
	.db	00100100b
	.db	00100100b
	
bdpo:
	.db	48,48,48,48,16,252,18,20
	.db	16,56,40,40,36,36,36,36

bgpi:	
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00100101b
	.db	01111010b
	.db	10100100b
	.db	10101000b
	.db	01010000b
	.db	00100000b
	.db	00100000b
	.db	00100000b
	.db	00100000b
	.db	00100000b
	.db	00100000b
	.db	00100000b

bdpi:
	.db	12,12,12,12,164,94,37,21
	.db	10,4,4,4,4,4,4,4

bgpog:	
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001000b
	.db	00011111b
	.db	00001000b
	.db	00001000b
	.db	00010100b
	.db	00010100b
	.db	00101000b
	.db	00101000b
	.db	01010000b
	.db	01010000b
	.db	10000000b
	.db	10000000b

bdpog:
	.db	48,48,48,48,16,248,16,16
	.db	40,40,20,20,10,10,1,1

bgpig:	
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00110000b
	.db	00100000b
	.db	00100000b
	.db	01111000b
	.db	10100100b
	.db	11101000b
	.db	00100000b
	.db	00100000b
	.db	00111111b
	.db	01000000b
	.db	01000000b
	.db	00111000b
	.db	00000000b
bdpig:
	.db	12,12,12,12,4,4,30,37
	.db	23,4,4,252,2,2,28,0


bgpk:	
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001000b
	.db	01111110b
	.db	01001010b
	.db	01001100b
	.db	00011000b
	.db	01101000b
	.db	00001000b
	.db	00011110b
	.db	00110010b
	.db	01100010b
	.db	11000010b
	.db	10000010b
bdpk:
	.db	48,48,48,48,16,126,82,50
	.db	24,22,16,120,76,70,67,65

bgek:	
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001001b
	.db	00001111b
	.db	00001111b
	.db	00001001b
	.db	00001000b
	.db	00001000b
	.db	00001000b
	.db	00011110b
	.db	00110010b
	.db	01100010b
	.db	11000010b
	.db	10000010b

bdek:
	.db	48,48,48,48,144,240,240,144
	.db	16,16,16,120,76,70,67,65

bgppo:	
	.db	01100000b
	.db	01100000b
	.db	01100000b
	.db	01100010b
	.db	00010100b
	.db	00111000b
	.db	01010000b
	.db	10010000b
	.db	00010000b
	.db	00101000b
	.db	00101000b
	.db	00101000b
	.db	00100100b
	.db	00100100b
	.db	00100100b
	.db	00100100b

bdppo:
	.db	6,6,6,70,40,28,10,9
	.db	8,20,20,20,36,36,36,36

bgppi:	
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00010000b
	.db	00111110b
	.db	00010000b
	.db	00010000b
	.db	00010000b
	.db	00101000b
	.db	00101000b
	.db	00010100b
	.db	00010100b
	.db	00001010b
	.db	00001011b
	.db	00000001b

bdppi:
	.db	48,48,48,48,8,124,8,8
	.db	8,20,20,40,40,80,208,128

bpen:
	.db	00111000b
	.db	00111000b
	.db	10111010b
	.db	10010010b
	.db	11010110b
	.db	01111100b
	.db	00010000b
	.db	00010000b
	.db	00010000b
	.db	00111000b
	.db	01101100b
	.db	01101100b
	.db	11000110b
	.db	10000010b
	.db	10000010b
	.db	10000010b

bgpr:
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001100b
	.db	00001001b
	.db	00001111b
	.db	00001111b
	.db	00001001b
	.db	00001000b
	.db	00010100b
	.db	00010100b
	.db	00010100b
	.db	00010100b
	.db	00010100b
	.db	00010100b
	.db	00010100b
bdpr:
	.db	48,48,48,48,144,240,240,144
	.db	16,40,40,40,40,40,40,40

dekg1:
	.db	0,0,0,0
	.db	00111111b
	.db	255,255
	.db	00111111b
	.db	0,0,0,0,0,0,0,0

dekd1:
	.db	0,0,0,0,252,255,255,252
	.db	0,0,0,0,0,0,0,0
dek2:
	.db	0
	.db	00011000b
	.db	00111100b
	.db	01111110b
	.db	11111111b
	.db	11111111b
	.db	11111111b
	.db	11111111b
	.db	01111110b
	.db	00111100b
	.db	00011000b
	.db	0,0,0,0,0


dekg3:
	.db	01111111b
	.db	01111111b
	.db	255,255,255,255
	.db	255,255,255,255	
	.db	01111111b
	.db	01111111b
	.db	0,0,0,0

dekd3:
	.db	254,254,255,255,255,255,255,255
	.db	255,255,254,254,0,0,0,0

kameha1:
	.db	0,0,0,0
	.db	11000000b	
	.db	11000000b
	.db	11000000b
	.db	11000000b
	.db	0,0,0,0
kameha2:
	.db	192,192,192,192,192,192,192,192
	.db	192,192,192,192

dbzlogo:

	.db	00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b
	.db	00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b
	.db	00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000011b,11111111b,11111111b,11111000b
	.db	00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000010b,00000000b,00000000b,00110000b
	.db	01111100b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000010b,00000000b,00000000b,01100000b
	.db	01000011b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000110b,00000000b,00000000b,01000000b
	.db	01000000b,11111110b,00000000b,00000000b,00000000b,00000000b,00000000b,00000011b,10000110b,00000000b,00000000b,10000000b
	.db	01000000b,01000011b,00000000b,00000000b,00000000b,00000000b,00000000b,00101100b,10000100b,00000000b,00000001b,10000000b
	.db	01100000b,00100000b,11111000b,00000000b,00000000b,00000000b,00001111b,11101000b,10000100b,00011111b,00000011b,00000000b
	.db	00100000b,00100000b,01000100b,00000000b,00000000b,00011111b,01111110b,00101000b,10000100b,00110110b,00000110b,00000000b
	.db	00100000b,00010000b,01000111b,11111100b,01111011b,11100001b,11000110b,00111001b,00001100b,01100100b,00001100b,01000000b
	.db	00100000b,00010000b,01000110b,00000110b,01001100b,01000000b,01000010b,00110001b,00001000b,01111100b,00001000b,11000000b
	.db	00110000b,00001010b,00100010b,00000001b,00000100b,01000000b,01100010b,00110001b,00001001b,11100000b,00011001b,10000000b
	.db	00010001b,00001010b,00100010b,00000001b,10000100b,01000000b,00100010b,00110001b,00001111b,01100000b,00110011b,10000000b
	.db	00011001b,10001010b,01000010b,00000001b,11000000b,01000100b,00100010b,00110001b,00001110b,01100000b,00100100b,10000000b
	.db	00011001b,10001010b,01010010b,00110011b,00100000b,01000100b,00110010b,00111011b,00011100b,01000000b,00111001b,10000000b
	.db	00001001b,10001000b,10000001b,11111100b,10010000b,01100000b,00100010b,00111111b,00011000b,10000000b,11110001b,00000000b
	.db	00001000b,00001001b,10000001b,11011000b,11010000b,01100000b,11000001b,00000111b,11010001b,10000001b,11100001b,00000000b
	.db	00001000b,00010000b,10000001b,10010011b,11010000b,01100000b,11000001b,00000100b,01000011b,00000011b,11000011b,00000000b
	.db	00001000b,00010000b,10011001b,11010011b,11010000b,01100000b,01010001b,00001000b,01000110b,00000011b,10000010b,00000000b
	.db	00001000b,00100000b,01011000b,11110011b,00010000b,01100100b,01111001b,00001000b,01000100b,00000000b,00000010b,00000000b
	.db	00001100b,00100100b,00111000b,10001000b,00010000b,01100000b,01111000b,10111000b,11001000b,00000000b,00000010b,00000000b
	.db	00000100b,01000100b,00111000b,10001000b,11100100b,01100000b,01111000b,11100000b,10010000b,00000000b,00000100b,00000000b
	.db	00000101b,11000110b,01101111b,10000111b,10001100b,01110001b,11111111b,11111111b,10110000b,00000000b,00000100b,00000000b
	.db	00000110b,01111111b,10001101b,11111001b,11111111b,11011111b,11101000b,00100110b,01100000b,00000000b,00001100b,00000000b
	.db	00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,00000000b,11111111b,11111111b,11111100b,00000000b


.end
END
